//-----------------------------LICENSE NOTICE------------------------------------
//	GNU GENERAL PUBLIC LICENSE - Version 3, 29 June 2007
//	For more info, read LICENSE.txt on source's root directory
//------------------------------------------------------------------------------

#include <cpctelera.h>
#include "enemigo.h"
#include "sprites.h"

#define VMEM (u8*)0xC000
#define PW 4 //personaje width
#define PH 8 //personaje height
#define EW 4 //enemigo width
#define EH 8 //enemigo height
#define TW 4 //tile width
#define TH 16 //tile height
#define MW 20 //mapa width
#define MH 11 //mapa height


void pintarEnemigo(u8 x, u8 y, u8 dir){
	u8* memptr;
	if(dir == 0){
		memptr = cpct_getScreenPtr(VMEM, x, y); 
		cpct_drawSprite(enem_dcha,memptr,EW,EH);
	}else
	if(dir == 1){
		memptr = cpct_getScreenPtr(VMEM, x, y); 
		cpct_drawSprite(enem_izda,memptr,EW,EH);
	}else
	if(dir == 2){
		memptr = cpct_getScreenPtr(VMEM, x, y); 
		cpct_drawSprite(enem_abajo,memptr,EW,EH);
	}
	if(dir == 3){
		memptr = cpct_getScreenPtr(VMEM, x, y); 
		cpct_drawSprite(enem_arriba,memptr,EW,EH);
	}
}

void borrarEnemigo(u8 x, u8 y){
	u8* memptr;
	memptr = cpct_getScreenPtr(VMEM, x, y); 
	cpct_drawSolidBox(memptr, cpct_px2byteM0(0, 0), EW, EH);
}

void comprobarRango(TEnemigo *e, u8 *scene[], u8 txp, u8 typ){

	u8 mapax, mapay, txe, tye, parar = 0;

	txe = (e->x+(EW/2)) / TW;
	tye = (e->y+(EH/2)) / TH;
	
	e->estado = 0;


	//Comprobar rango vision
	for(mapax=txe; mapax<MW && !parar; mapax++){
	  if(scene[tye][mapax] == 1){ //hay muro, no se ve más allá
	    parar = 1;
	  }else{
	    //si está el personaje
	    if(mapax == txp && (tye == typ || tye == typ+1 || tye == typ-1)){ 
	      e->estado = 1;
	    }
	  }
	}

	parar = 0;

	for(mapax=txe-1; mapax>0 && !parar; mapax--){
	  if(scene[tye][mapax] == 1){ //hay muro, no se ve más allá
	    parar = 1;
	  }else{
	    //si está el personaje
	    if(mapax == txp && (tye == typ || tye == typ+1 || tye == typ-1)){ 
	      e->estado = 1;
	    }
	  }
	}

	parar = 0;

	for(mapay=tye; mapay<MH && !parar; mapay++){
	  if(scene[mapay][txe] == 1){ //hay muro, no se ve más allá
	    parar = 1;
	  }else{
	    //si está el personaje
	    if(mapay == typ && (txe == txp || txe == txp+1 || txe == txp-1)){ 
	      e->estado = 1;
	    }
	  }
	}

	parar = 0;

	for(mapay=tye-1; mapay>0 && !parar; mapay--){
	  if(scene[mapay][txe] == 1){ //hay muro, no se ve más allá
	    parar = 1;
	  }else{
	    //si está el personaje
	    if(mapay == typ && (txe == txp || txe == txp+1 || txe == txp-1)){ 
	      e->estado = 1;
	    }
	  }
	}

}

void patrullar(TEnemigo *e, u8 *scene[]){

	u8 txe, tye, tye2, txe3, txe4, tye4;

	//Tile enemigo:

	//Esquina izq-arriba
	txe = (e->x) / TW;
	tye = (e->y) / TH;
	//Esquina izq-abajo
	tye2 = (e->y+EH) / TH;
	//Esquina der-arriba
	txe3 = (e->x+EW) / TW;
	//Esquina der-abajo
	txe4 = (e->x+EW) / TW;
	tye4 = (e->y+EH) / TH;


	if(e->tipo == 0){ //horizontal

		//si no está entre dos paredes
		if((scene[tye][(e->x+EW+1) / TW] == 0 && scene[tye4][(e->x+EW+1) / TW] == 0) || (scene[tye][(e->x-1) / TW] == 0 && scene[tye2][(e->x-1) / TW] == 0)){
			if(e->x > e->xIn+14 || e->x < e->xIn-10){ //si no está en su recorrido inicial, cambiar posición inicial
				e->xIn == e->x;
			}

			//Patrullar
			if(e->x < e->xIn+14 && e->dir == 0 && scene[tye][(e->x+EW+1) / TW] == 0 && scene[tye4][(e->x+EW+1) / TW] == 0){ // no hay muro der
				e->x++;

				if(e->x == e->xIn+14){
					e->dir = 1;
				}

			}else if(e->x > e->xIn-10 && e->dir == 1 && scene[tye][(e->x-1) / TW] == 0 && scene[tye2][(e->x-1) / TW] == 0){ //no hay muro izq
				e->x--;

				if(e->x == e->xIn-10){
					e->dir = 0;
				}
			}else if(e->dir == 1){
				e->dir = 0;
			}else{
				e->dir = 1;
			}
		}

		
	}else if(e->tipo == 1){ //vertical

		//si no está entre dos paredes
		if((scene[(e->y+EH+4) / TH][txe] == 0 && scene[(e->y+EH+4) / TH][txe4] == 0) || (scene[(e->y-4) / TH][txe] == 0 && scene[(e->y-4) / TH][txe3] == 0)){
			if(e->y > e->yIn+18 || e->y < e->yIn-10){ //si no está en su recorrido inicial, cambiar posición inicial
				e->yIn == e->y;
			}

			if(e->y < e->yIn+18 && e->dir == 2 && scene[(e->y+EH+4) / TH][txe] == 0 && scene[(e->y+EH+4) / TH][txe4] == 0){ // no hay muro abajo
				e->y+=4;

				if(e->y == e->yIn+18){
					e->dir = 3;
				}

			}else if(e->y > e->yIn-10 && e->dir == 3 && scene[(e->y-4) / TH][txe] == 0 && scene[(e->y-4) / TH][txe3] == 0){ //no hay muro arriba
				e->y-=4;

				if(e->y == e->yIn-10){
					e->dir = 2;
				}
			}else if(e->dir == 3){
				e->dir = 2;
			}else{
				e->dir = 3;
			}
		}
		
	}
	
}

u8 atacar(TEnemigo *e, TPersonaje *p, u8 *scene[]){

	u8 txe, tye, tye2, txe3, txe4, tye4, txp, typ, otro = 0;

	//Tile enemigo:

	//Esquina izq-arriba
	txe = (e->x) / TW;
	tye = (e->y) / TH;
	//Esquina izq-abajo
	tye2 = (e->y+EH) / TH;
	//Esquina der-arriba
	txe3 = (e->x+EW) / TW;
	//Esquina der-abajo
	txe4 = (e->x+EW) / TW;
	tye4 = (e->y+EH) / TH;

	//Tile personaje
	txp = (p->x+(PW/2)) / TW;
	typ = (p->y+(PH/2)) / TH;


	if(p->x < e->x){ // p está a la izquierda
		if(scene[tye][(e->x-1) / TW] == 0 && scene[tye2][(e->x-1) / TW] == 0){ //no hay muro a la izq
			e->x--;
			e->dir = 1; 
		}else{ //hay muro a la izq
			otro = 1;
		}
		
	}else if(p->x > e->x){ //p está a la derecha
		if(scene[tye][(e->x+EW+1) / TW] == 0 && scene[tye4][(e->x+EW+1) / TW] == 0){ //no hay muro a la der
			e->x++;
			e->dir = 0;
		}else{ //hay muro a la der
			otro = 1;
		}
	}if(p->x == e->x || otro == 1){ // p esta en la misma x
		otro = 0;
		if(p->y <= e->y){ // p esta arriba
			if(scene[(e->y-4) / TH][txe] == 0 && scene[(e->y-4) / TH][txe3] == 0){ //no hay muro arriba
				e->y -= 4;
				e->dir = 3;
			}else{ //hay muro arriba
				otro = 1;
			}	

		}else if(p->y > e->y){ //p esta abajo
			otro = 0;
			if(scene[(e->y+EH+4) / TH][txe] == 0 && scene[(e->y+EH+4) / TH][txe4] == 0){ //no hay muro abajo
				e->y += 4;
				e->dir = 2;
			}else{//hay muro abajo.
				otro = 1;
			}
		}
		if(otro == 1){
			if(e->dir == 1){ //e tiene direccion izq
				if(scene[tye][(e->x-1) / TW] == 0 && scene[tye2][(e->x-1) / TW] == 0){ //no hay muro izq
					e->x--;
					e->dir = 1;
				}else{
					if(scene[tye][(e->x+EW+1) / TW] == 0 && scene[tye4][(e->x+EW+1) / TW] == 0){ //no hay muro der
						e->x++;
						e->dir = 0;
					}
				}
			}else{ //e tiene otra direccion
				if(scene[tye][(e->x+EW+1) / TW] == 0 && scene[tye4][(e->x+EW+1) / TW] == 0){ //no hay muro der
					e->x++;
					e->dir = 0;
				}else{
					if(scene[tye][(e->x-1) / TW] == 0 && scene[tye2][(e->x-1) / TW] == 0){ //no hay muro izq
						e->x--;
						e->dir = 1;
					}
				}
			}
		}
	}

	//Esquina izq-arriba
	txe = (e->x) / TW;
	tye = (e->y) / TH;
	//Esquina izq-abajo
	tye2 = (e->y+EH) / TH;
	//Esquina der-arriba
	txe3 = (e->x+EW) / TW;
	//Esquina der-abajo
	txe4 = (e->x+EW) / TW;
	tye4 = (e->y+EH) / TH;

	//Comprobar que cualquierda de las esquinas del enemigo, coincida con el tile del personaje
	if((txe == txp && tye == typ) || (txe == txp && tye2 == typ) || (txe3 == txp && tye == typ) || (txe4 == txp && tye4 == typ)){
		p->vida--;

		return 1;

	}

	return 0;
}

void huir(TEnemigo *e, u8 xP, u8 yP, u8 *scene[]){

	u8 txe, tye, tye2, txe3, txe4, tye4, txp, typ, otro1 = 0, otro2 = 0;

	//Tile enemigo:

	//Esquina izq-arriba
	txe = (e->x) / TW;
	tye = (e->y) / TH;
	//Esquina izq-abajo
	tye2 = (e->y+EH) / TH;
	//Esquina der-arriba
	txe3 = (e->x+EW) / TW;
	//Esquina der-abajo
	txe4 = (e->x+EW) / TW;
	tye4 = (e->y+EH) / TH;

	//Tile personaje
	txp = (xP+(PW/2)) / TW;
	typ = (yP+(PH/2)) / TH;

	if(txp < txe){ // p está a la izquierda
		
		if(scene[tye][(e->x+EW+1) / TW] == 0 && scene[tye4][(e->x+EW+1) / TW] == 0){ //no hay muro a la der
			e->x++;
			e->dir = 0;
		}else{ //hay muro a la der
			otro1 = 1;
		}
	}else if(txp > txe){ //p está a la derecha
		if(scene[tye][(e->x-1) / TW] == 0 && scene[tye2][(e->x-1) / TW] == 0){ //no hay muro a la izq
			e->x--;
			e->dir = 1; 
		}else{ //hay muro a la izq
			otro1 = 1;
		}
	}else{ // p esta en la misma x
		if(yP <= e->y){ // p esta arriba
			if(scene[(e->y+EH+4) / TH][txe] == 0 && scene[(e->y+EH+4) / TH][txe4] == 0){ //no hay muro abajo
				e->y += 4;
				e->dir = 2;
			}else{//hay muro abajo
				otro2 = 1;
			}		

		}else if(yP > e->y){ //p esta abajo
			if(scene[(e->y-4) / TH][txe] == 0 && scene[(e->y-4) / TH][txe3] == 0){ //no hay muro arriba
				e->y -= 4;
				e->dir = 3;
			}else{ //hay muro arriba
				otro2 = 1;
			}
		}
	}

	if(otro1 == 1){
			if(e->dir == 2){ // p esta arriba o e tiene direccion abajo
				if(scene[(e->y+EH+4) / TH][txe] == 0 && scene[(e->y+EH+4) / TH][txe4] == 0){ //no hay muro abajo
					e->y += 4;
					e->dir = 2;
				}else{
					if(scene[(e->y-4) / TH][txe] == 0 && scene[(e->y-4) / TH][txe3] == 0){ //no hay muro arriba
						e->y -= 4;
						e->dir = 3;
					}
				}
			}else{
				if(scene[(e->y-4) / TH][txe] == 0 && scene[(e->y-4) / TH][txe3] == 0){ //no hay muro arriba
					e->y -= 4;
					e->dir = 3;
				}else{
					if(scene[(e->y+EH+4) / TH][txe] == 0 && scene[(e->y+EH+4) / TH][txe4] == 0){ //no hay muro abajo
						e->y += 4;
						e->dir = 2;
					}
				}
			}
		}

		if(otro2 == 1){
			if(e->dir == 1){ //e tiene direccion izq
				if(scene[tye][(e->x-1) / TW] == 0 && scene[tye2][(e->x-1) / TW] == 0){ //no hay muro izq
					e->x--;
					e->dir = 1;
				}else{
					if(scene[tye][(e->x+EW+1) / TW] == 0 && scene[tye4][(e->x+EW+1) / TW] == 0){ //no hay muro der
						e->x++;
						e->dir = 0;
					}
				}
			}else{ //e tiene otra direccion
				if(scene[tye][(e->x+EW+1) / TW] == 0 && scene[tye4][(e->x+EW+1) / TW] == 0){ //no hay muro der
					e->x++;
					e->dir = 0;
				}else{
					if(scene[tye][(e->x-1) / TW] == 0 && scene[tye2][(e->x-1) / TW] == 0){ //no hay muro izq
						e->x--;
						e->dir = 1;
					}
				}
			}
		}
}
