//-----------------------------LICENSE NOTICE------------------------------------
//	GNU GENERAL PUBLIC LICENSE - Version 3, 29 June 2007
//	For more info, read LICENSE.txt on source's root directory
//------------------------------------------------------------------------------

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
//// GAME MODULE
////   Controls all the high-level logic that implements the game
////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

#ifndef _ENEMIGO_H_
#define _ENEMIGO_H_

#include <types.h>

typedef struct{

  u8 x, y, antorcha, llave, vida; //Posición x e y del personaje, cada uno tiene un valor de 0-255
  u8 *sprite;

}TPersonaje;

typedef struct{

  u8 xIn, yIn, xAnt, yAnt, x, y, tipo, estado, dir; //tipo-> 0.horizontal, 1.vertical
										//estado-> 0.patrulla, 1.ataque
										//dir-> 0.derecha 1.izquierda 2.abajo 3.arriba	

}TEnemigo;



//
// Functions defined in the game module
//

void pintarEnemigo(u8 x, u8 y, u8 dir);
void borrarEnemigo(u8 x, u8 y);
void comprobarRango(TEnemigo *e, u8 *scene[], u8 txp, u8 typ);
void patrullar(TEnemigo *e, u8 *scene[]);
u8 atacar(TEnemigo *e, TPersonaje *p, u8 *scene[]);
void huir(TEnemigo *e, u8 xP, u8 yP, u8 *scene[]);

#endif