//-----------------------------LICENSE NOTICE------------------------------------
//	GNU GENERAL PUBLIC LICENSE - Version 3, 29 June 2007
//	For more info, read LICENSE.txt on source's root directory
//------------------------------------------------------------------------------

#include <cpctelera.h>
#include "menu.h"
#include "sprites.h"

#define VMEM (u8*)0xC000
#define PW 4 //personaje width
#define PH 8 //personaje height


void controles(){
  u8* memptr;
  cpct_clearScreen(0);

  memptr = cpct_getScreenPtr(VMEM, 23, 30); 
  cpct_drawStringM0("Controles", memptr, 15, 0); 

  memptr = cpct_getScreenPtr(VMEM, 20, 60); 
  cpct_drawStringM0("Movimiento:", memptr, 10, 0); 

  memptr = cpct_getScreenPtr(VMEM, 15, 80); 
  cpct_drawStringM0("WASD o flechas", memptr, 10, 0); 

  memptr = cpct_getScreenPtr(VMEM, 20, 110); 
  cpct_drawStringM0("Esc: Menu", memptr, 10, 0);
  
  memptr = cpct_getScreenPtr(VMEM, 12, 175); 
  cpct_drawStringM0("Pulsa una tecla", memptr, 15, 0); 

  //Esperar hasta pulsar tecla
  do{
    cpct_scanKeyboard_f();

    if(cpct_isAnyKeyPressed ()){
      controles2();
    }
  }while(!cpct_isAnyKeyPressed ()); 

}

u8 controles2(){
  u8* memptr;
  cpct_clearScreen(0);

  memptr = cpct_getScreenPtr(VMEM, 29, 30); 
  cpct_drawStringM0("Juego", memptr, 15, 0);

  memptr = cpct_getScreenPtr(VMEM, 4, 55); 
  cpct_drawStringM0("Coge llave y avanza", memptr, 10, 0); 
  
  memptr = cpct_getScreenPtr(VMEM, 5, 85); 
  cpct_drawStringM0("Enciende antorchas", memptr, 10, 0); 
  
  memptr = cpct_getScreenPtr(VMEM, 6, 105); 
  cpct_drawStringM0("y aleja enemigos", memptr, 10, 0); 
  
  memptr = cpct_getScreenPtr(VMEM, 10, 130); 
  cpct_drawStringM0("Tienes 3 vidas", memptr, 10, 0);

  
  memptr = cpct_getScreenPtr(VMEM, 12, 175); 
  cpct_drawStringM0("Pulsa una tecla", memptr, 15, 0); 

  //Esperar hasta pulsar tecla
  do{
    cpct_scanKeyboard_f();

    if(cpct_isAnyKeyPressed()){
      return 3;
    }
  }while(!cpct_isAnyKeyPressed()); 

  return 0;
}


u8 creditos(){
  u8* memptr;
  cpct_clearScreen(0);

  memptr = cpct_getScreenPtr(VMEM, 18, 30); 
  cpct_drawStringM0("Grupo Pyxis", memptr, 15, 0); 

  memptr = cpct_getScreenPtr(VMEM, 23, 60); 
  cpct_drawStringM0("Miembros:", memptr, 7, 0); 
  
  memptr = cpct_getScreenPtr(VMEM, 17, 80); 
  cpct_drawStringM0("Ana Martinez", memptr, 10, 0); 
  memptr = cpct_getScreenPtr(VMEM, 27, 95); 
  cpct_drawStringM0("Aleman", memptr, 10, 0); 
  
  memptr = cpct_getScreenPtr(VMEM, 13, 115); 
  cpct_drawStringM0("Alejandro Mayol", memptr, 10, 0);
  memptr = cpct_getScreenPtr(VMEM, 27, 125); 
  cpct_drawStringM0("Carrion", memptr, 10, 0);  

  memptr = cpct_getScreenPtr(VMEM, 12, 175); 
  cpct_drawStringM0("Pulsa una tecla", memptr, 15, 0); 

  //Esperar hasta pulsar tecla
  do{
    cpct_scanKeyboard_f();

    if(cpct_isAnyKeyPressed()){
      return 3;
    }
  }while(!cpct_isAnyKeyPressed()); 

  return 0;
}

void gameOver(){
  u8* memptr;

  //Borrar pantalla
  cpct_clearScreen(0);

  memptr = cpct_getScreenPtr(VMEM, 23, 50); 
  cpct_drawStringM0("GAME OVER", memptr, 10, 0); 

  memptr = cpct_getScreenPtr(VMEM, 36, 70); 
  cpct_drawStringM0(":(", memptr, 10, 0); 

  memptr = cpct_getScreenPtr(VMEM, 12, 175); 
  cpct_drawStringM0("Pulsa una tecla", memptr, 15, 0); 

   //Esperar hasta pulsar tecla
  do{
    cpct_scanKeyboard_f();

    if(cpct_isAnyKeyPressed()){
      return;
    }

  }while(!cpct_isAnyKeyPressed()); 
}

void ganar(){
  u8* memptr;

  //Borrar pantalla
  cpct_clearScreen(0);

  memptr = cpct_getScreenPtr(VMEM, 18, 50); 
  cpct_drawStringM0("HAS GANADO!!", memptr, 15, 0); 

  memptr = cpct_getScreenPtr(VMEM, 18, 70); 
  cpct_drawStringM0("Bien hecho :)", memptr, 15, 0); 

  memptr = cpct_getScreenPtr(VMEM, 12, 175); 
  cpct_drawStringM0("Pulsa una tecla", memptr, 15, 0); 

   //Esperar hasta pulsar tecla
  do{
    cpct_scanKeyboard_f();

    if(cpct_isAnyKeyPressed()){
      return;
    }

  }while(!cpct_isAnyKeyPressed()); 
}

//Menú
u8 menu(){

  u8* memptr;
  u8 yP = 30, yE = 150, xE = 31, dirP = 1, dirE = 0, dirE2 = 0, wait = 0; //1.abajo, 0.arriba

  //Borrar pantalla
  cpct_clearScreen(0);

  memptr = cpct_getScreenPtr(VMEM, 23, 20); //Escribir en la posición 23,20
  cpct_drawSprite(titulo,memptr,34,19);

  memptr = cpct_getScreenPtr(VMEM, 19, 80); 
  cpct_drawStringM0("1.Jugar", memptr, 15, 0); 

  memptr = cpct_getScreenPtr(VMEM, 19, 100); 
  cpct_drawStringM0("2.Controles", memptr, 15, 0); 
  
  memptr = cpct_getScreenPtr(VMEM, 19, 120); 
  cpct_drawStringM0("3.Creditos", memptr, 15, 0); 

  //Esperar hasta pulsar tecla
  do{
  cpct_waitVSYNC();
  if(wait == 2){
    ////////////////////personaje
    if(dirP == 1){//va hacia abajo
    
      memptr = cpct_getScreenPtr(VMEM, 10, yP-4); 
      cpct_drawSolidBox(memptr, 0, PW, PH);
      
      memptr = cpct_getScreenPtr(VMEM, 10, yP);
      cpct_drawSpriteMasked(pj_abajo, memptr, PW, PH);
    
      
      yP+=4;
      if(yP > 150){
        dirP = 0;
      }
    }else{ //va hacia arriba
      memptr = cpct_getScreenPtr(VMEM, 10, yP+4); 
      cpct_drawSolidBox(memptr, 0, PW, PH);
      
      memptr = cpct_getScreenPtr(VMEM, 10, yP);
      cpct_drawSpriteMasked(pj_arriba, memptr, PW, PH);
      
      yP-=4;
      if(yP < 30){
        dirP = 1;
      }
    }
    /////fin pj
    //////enemigo
    if(dirE == 1){//va hacia abajo
    
      memptr = cpct_getScreenPtr(VMEM, 150, yE-4); 
      cpct_drawSolidBox(memptr, 0, PW, PH);
      
      memptr = cpct_getScreenPtr(VMEM, 150, yE);
      cpct_drawSprite(enem_abajo, memptr, PW, PH);
    
      
      yE+=4;
      if(yE > 150){
        dirE = 0;
      }
    }else{ //va hacia arriba
      memptr = cpct_getScreenPtr(VMEM, 150, yE+4); 
      cpct_drawSolidBox(memptr, 0, PW, PH);
      
      memptr = cpct_getScreenPtr(VMEM, 150, yE);
      cpct_drawSprite(enem_arriba, memptr, PW, PH);
      
      yE-=4;
      if(yE < 30){
        dirE = 1;
      }
    }
    ///////enemigo 2 horizontal
    if(dirE2 == 1){//va hacia der
    
      memptr = cpct_getScreenPtr(VMEM, xE-1, 150); 
      cpct_drawSolidBox(memptr, 0, PW, PH);
      
      memptr = cpct_getScreenPtr(VMEM, xE, 150);
      cpct_drawSprite(enem_dcha, memptr, PW, PH);
    
      xE++;
      if(xE > 60){
        dirE2 = 0;
      }
    }else{ //va hacia izda
      memptr = cpct_getScreenPtr(VMEM, xE+1, 150); 
      cpct_drawSolidBox(memptr, 0, PW, PH);
      
      memptr = cpct_getScreenPtr(VMEM, xE, 150);
      cpct_drawSprite(enem_izda, memptr, PW, PH);
      
      xE--;
      if(xE < 15){
        dirE2 = 1;
      }
    }
    /////////fin enemigo 2
    wait = 0;
  }else
    wait++;
  
    cpct_scanKeyboard_f();
  
    if(cpct_isKeyPressed(Key_1)){
    return 1;
    }else if(cpct_isKeyPressed(Key_2)){
    return 2;
    }else if(cpct_isKeyPressed(Key_3)){
    return 3;
  }
  }while(!cpct_isKeyPressed(Key_1) && !cpct_isKeyPressed(Key_2) && !cpct_isKeyPressed(Key_3)); 
  return 0;
}
